 
 import "Turbine.UI"; 
 import "Turbine.UI.Extensions"; 
 import "Turbine.UI.Lotro"; 

 import "Homeopatix.Escarmouche.Globals"
 import "Homeopatix.Escarmouche.MinimizedIcon"
 import "Homeopatix.Escarmouche.VindarPatch"
 import "Homeopatix.Escarmouche.Commands"
 import "Homeopatix.Escarmouche.LoadSettings"

Turbine.Shell.WriteLine("<rgb=#CC56DA>Escarmouche</rgb> <rgb=#DDDDDD>".. plugin:GetVersion() .." par Homeo</rgb>")

function SaveSettings()
		settings.positionX = tostring(settings.positionX);
   		settings.positionY = tostring(settings.positionY);
		settings.minimizeX = tostring(settings.minimizeX);
   		settings.minimizeY = tostring(settings.minimizeY);
		settings.isWindowVisible = settings.isWindowVisible;
		settings.shortcutData_1 = tostring(settings.shortcutData_1);
   		settings.shortcutData_2 = tostring(settings.shortcutData_2);
   		settings.escEnable = settings.escEnable;
   
   -- save the settings
	PatchDataSave( Turbine.DataScope.Character, "Escarmouche_Settings", settings);
end

CreateLocalizationInfo();
LoadSettings();

------------------------------------------------------------------------------------------
-- create the main window
------------------------------------------------------------------------------------------
EscarmoucheWindow=Turbine.UI.Lotro.GoldWindow(); 
EscarmoucheWindow:SetSize(200,100); 
EscarmoucheWindow:SetText(Strings.PluginName); 
EscarmoucheWindow.Message=Turbine.UI.Label(); 
EscarmoucheWindow.Message:SetParent(EscarmoucheWindow); 
EscarmoucheWindow.Message:SetSize(150,10); 
EscarmoucheWindow.Message:SetPosition(EscarmoucheWindow:GetWidth()/2 - 75, EscarmoucheWindow:GetHeight()/2 + 30); 
EscarmoucheWindow.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
EscarmoucheWindow.Message:SetText(Strings.PluginText); 
EscarmoucheWindow:SetVisible(settings.isWindowVisible);
EscarmoucheWindow:SetWantsKeyEvents(true);

EscarmoucheWindow:SetPosition(settings.positionX, settings.positionY);

------------------------------------------------------------------------------------------
-- escarmouche helper center window
------------------------------------------------------------------------------------------
centerWindow = Turbine.UI.Extensions.SimpleWindow();
centerWindow:SetSize( 36 , 36 );
centerWindow:SetParent( EscarmoucheWindow );
centerWindow:SetPosition( 55 ,EscarmoucheWindow:GetHeight()/2 - 12);
centerWindow:SetVisible( true );
centerWindow:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow2 = Turbine.UI.Extensions.SimpleWindow();
centerWindow2:SetSize( 36 , 36 );
centerWindow2:SetParent( EscarmoucheWindow );
centerWindow2:SetPosition( 110 ,EscarmoucheWindow:GetHeight()/2 - 12);
centerWindow2:SetVisible( true );
centerWindow2:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow2);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerQS1 = Turbine.UI.Lotro.Quickslot();
centerQS1:SetParent( centerWindow );
centerQS1:SetPosition( 0, 0 );
centerQS1:SetSize( 35, 35 );
centerQS1:SetUseOnRightClick(false);
centerQS1:SetWantsUpdates(true);

centerQS2 = Turbine.UI.Lotro.Quickslot();
centerQS2:SetParent( centerWindow2 );
centerQS2:SetPosition( 0, 0 );
centerQS2:SetSize( 35, 35 );
centerQS2:SetUseOnRightClick(false);
centerQS2:SetWantsUpdates(true);

------------------------------------------------------------------------------------------
-- handle minimizeIcon
------------------------------------------------------------------------------------------
MainMinimizedIcon = MinimizedIcon(Images.MinimizedIcon, 40, 40, EscarmoucheWindow:SetVisible(false));
settings.isWindowVisible = false;
SaveSettings();
MainMinimizedIcon:SetPosition(settings.minimizeX, settings.minimizeY);
MainMinimizedIcon:SetZOrder(0);
MainMinimizedIcon.PositionChanged = function()
	settings.minimizeX = MainMinimizedIcon:GetLeft();
	settings.minimizeY = MainMinimizedIcon:GetTop();
	SaveSettings();
end

function EscarmoucheWindow:Closing(sender, args)
	settings.isWindowVisible = false;
	SaveSettings();
end
------------------------------------------------------------------------------------------
-- setting the shortcuts
------------------------------------------------------------------------------------------

if(settings.shortcutData_1 ~= "") then
	centerQS1:SetShortcut( Turbine.UI.Lotro.Shortcut( 6, settings.shortcutData_1 ) );
end

if(settings.shortcutData_2 ~= "") then
	centerQS2:SetShortcut( Turbine.UI.Lotro.Shortcut( 6, settings.shortcutData_2 ) );
end

settings.shortcutData_1 = "0x7001AA28"; -- fishing
settings.shortcutData_2 = "0x7001C4C8"; -- canne a peche en lebthron

------------------------------------------------------------------------------------------
-- mouse click handler
------------------------------------------------------------------------------------------
centerQS1.MouseEnter = function(sender, args)
	EscarmoucheWindow.Message:SetText(""); 
	EscarmoucheWindow.Message:SetText(Strings.PluginText_1); 
end

centerQS2.MouseEnter = function(sender, args)
	EscarmoucheWindow.Message:SetText("");
	EscarmoucheWindow.Message:SetText(Strings.PluginText_2); 
end

centerQS1.MouseLeave = function(sender, args)
	EscarmoucheWindow.Message:SetText(Strings.PluginText);
end

centerQS2.MouseLeave = function(sender, args)
	EscarmoucheWindow.Message:SetText(Strings.PluginText);
end

------------------------------------------------------------------------------------------
-- setting the shortcuts for drag and drop
------------------------------------------------------------------------------------------
centerQS1.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS1:GetShortcut();
	tmp = tmp:GetData();
	
	local tmp2 = Turbine.UI.Lotro.Quickslot();
	tmp2 = centerQS1:GetShortcut();
	tmp2 = tmp2:GetType();

	
	--Turbine.Shell.WriteLine("Data : " .. tmp); -- display the ID of the schortcut
	--Turbine.Shell.WriteLine("Type : " .. tmp2); -- display the Type of the schortcut

	settings.shortcutData_1 = tmp;

	SaveSettings();
end
centerQS2.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS2:GetShortcut();
	tmp = tmp:GetData();
	
	settings.shortcutData_2 = tmp;

	SaveSettings();
end

------------------------------------------------------------------------------------------
-- event handling
------------------------------------------------------------------------------------------

EscarmoucheWindow.KeyDown=function(sender, args)
	if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
		EscarmoucheWindow:SetVisible(false);
		settings.isWindowVisible = false;
		SaveSettings();
	end
	
	-- https://www.lotro.com/forums/showthread.php?493466-How-to-hide-a-window-on-F12&p=6581962#post6581962
	if ( args.Action == 268435635 ) then
		hudVisible=not hudVisible;
		if hudVisible then
			EscarmoucheWindow:SetVisible(false);
			MainMinimizedIcon:SetVisible(false);
		else
			EscarmoucheWindow:SetVisible(settings.isWindowVisible);
			MainMinimizedIcon:SetVisible(true);
		end
	end
end

------------------------------------------------------------------------------------------
-- if the position changes, save the new window location
------------------------------------------------------------------------------------------
EscarmoucheWindow.PositionChanged = function( sender, args )
    local x,y = EscarmoucheWindow:GetPosition();
    settings.positionX = x;
    settings.positionY = y;
	SaveSettings();
end
				
	



